IT-Swarm.Net

如何判断Bash中是否存在常规文件?

我使用以下脚本来查看文件是否存在:

#!/bin/bash

FILE=$1     
if [ -f $FILE ]; then
   echo "File $FILE exists."
else
   echo "File $FILE does not exist."
fi

如果我只想检查文件是否存在,那么使用正确的语法是什么?

#!/bin/bash

FILE=$1     
if [ $FILE does not exist ]; then
   echo "File $FILE does not exist."
fi
2911
Bill the Lizard

test 命令(此处[)有一个“not”逻辑运算符,它是感叹号(类似于许多其他语言)。试试这个:

if [ ! -f /tmp/foo.txt ]; then
    echo "File not found!"
fi
4098
John Feminella

Bash文件测试

-b filename - 阻止特殊文件
-c filename - 特殊字符文件
-d directoryname - 检查目录是否存在
-e filename - 检查文件是否存在,无论类型如何(节点,目录,套接字等)
-f filename - 检查常规文件是否存在而不是目录
-G filename - 检查文件是否存在并由有效组ID拥有
-G filename set-group-id - 如果文件存在且为set-group-id,则为真
-k filename - 粘性位
-L filename - 符号链接
-O filename - 如果文件存在并且由有效用户ID拥有,则为真
-r filename - 检查文件是否可读
-S filename - 检查文件是否为套接字
-s filename - 检查文件是否为非零大小
-u filename - 检查文件set-user-id位是否已设置
-w filename - 检查文件是否可写
-x filename - 检查文件是否可执行

如何使用:

#!/bin/bash
file=./file
if [ -e "$file" ]; then
    echo "File exists"
else 
    echo "File does not exist"
fi 

A 测试表达式 可以通过使用!运算符来否定

#!/bin/bash
file=./file
if [ ! -e "$file" ]; then
    echo "File does not exist"
else 
    echo "File exists"
fi 
570
BlueCacti

你可以用“!”来否定表达式:

#!/bin/bash
FILE=$1

if [ ! -f "$FILE" ]
then
    echo "File $FILE does not exist"
fi

对于内置的bash命令,相关的手册页是man test或等效的man [ - 或help testhelp [

271
unbeknown
[[ -f $FILE ]] || printf '%s does not exist!\n' "$FILE"

此外,文件可能是破碎的符号链接,或非常规文件,例如,套接字,设备或fifo。例如,要添加对损坏的符号链接的检查:

if [[ ! -f $FILE ]]; then
    if [[ -L $FILE ]]; then
        printf '%s is a broken symlink!\n' "$FILE"
    else
        printf '%s does not exist!\n' "$FILE"
    fi
fi
124
guns

值得一提的是,如果你需要执行一个命令,你可以缩写

if [ ! -f "$file" ]; then
    echo "$file"
fi

test -f "$file" || echo "$file"

要么

[ -f "$file" ] || echo "$file"
88
Elazar Leibovich

我喜欢在 _ posix _ Shell兼容格式中执行以下单行程:

$ [ -f "/$DIR/$FILE" ] || echo "$FILE NOT FOUND"

$ [ -f "/$DIR/$FILE" ] && echo "$FILE FOUND"

对于一些命令,就像我在脚本中所做的那样:

$  [ -f "/$DIR/$FILE" ] || { echo "$FILE NOT FOUND" ; exit 1 ;}

一旦我开始这样做,我很少再使用完全类型化的语法!

63
J. M. Becker

要测试文件是否存在,参数可以是以下任何一个:

-e: Returns true if file exists (regular file, directory, or symlink)
-f: Returns true if file exists and is a regular file
-d: Returns true if file exists and is a directory
-h: Returns true if file exists and is a symlink

以下所有测试都适用于常规文件,目录和符号链接:

-r: Returns true if file exists and is readable
-w: Returns true if file exists and is writable
-x: Returns true if file exists and is executable
-s: Returns true if file exists and has a size > 0

示例脚本:

#!/bin/bash
FILE=$1

if [ -f "$FILE" ]; then
   echo "File $FILE exists"
else
   echo "File $FILE does not exist"
fi
48
SD.

你可以这样做:

[[ ! -f "$FILE" ]] && echo "File doesn't exist"

要么

if [[ ! -f "$FILE" ]]; then
    echo "File doesn't exist"
fi

如果要同时检查文件和文件夹,请使用-e选项而不是-f-e对常规文件,目录,套接字,字符特殊文件,块特殊文件等返回true。

33
Jahid

对于不带引号的变量,应该小心运行test,因为它可能会产生意外的结果:

$ [ -f ]
$ echo $?
0
$ [ -f "" ]
$ echo $?
1

建议通常是让测试变量用双引号括起来:

#!/bin/sh
FILE=$1

if [ ! -f "$FILE" ]
then
   echo "File $FILE does not exist."
fi
30
artdanil

有三种不同的方法可以做到这一点:

  1. 用bash否定退出状态(没有其他答案说过这个):

    if ! [ -e "$file" ]; then
        echo "file does not exist"
    fi
    

    要么:

    ! [ -e "$file" ] && echo "file does not exist"
    
  2. 否定测试命令[中的测试(这是之前大多数答案的方式):

    if [ ! -e "$file" ]; then
        echo "file does not exist"
    fi
    

    要么:

    [ ! -e "$file" ] && echo "file does not exist"
    
  3. 根据测试结果为负(||而不是&&):

    只要:

    [ -e "$file" ] || echo "file does not exist"
    

    这看起来很愚蠢(IMO),除非您的代码必须可移植到缺少管道否定运算符(/bin/sh)的Bourne Shell(如Solaris 10或更早版本的!),否则不要使用它:

    if [ -e "$file" ]; then
        :
    else
        echo "file does not exist"
    fi
    
21
user2350426

[ -f "$file" ]

[命令对存储在$file中的路径执行stat()(非lstat())系统调用,如果系统调用成功,则返回 true stat()返回的文件类型为“ regular ”。

因此,如果[ -f "$file" ]返回true,则可以告诉文件确实存在,并且是常规文件或符号链接最终解析为常规文件(或者至少是stat()时)。

但是,如果它返回 false (或者如果[ ! -f "$file" ]! [ -f "$file" ]返回true),则有许多不同的可能性:

  • 该文件不存在
  • 文件存在但不是 regular file(可以是设备,fifo,目录,套接字......)
  • 该文件存在但您没有父目录的搜索权限
  • 该文件存在,但访问它的路径太长
  • 该文件是常规文件的符号链接,但您没有对符号链接解析中涉及的某些目录的搜索权限。
  • ... stat()系统调用可能失败的任何其他原因。

简而言之,它应该是:

if [ -f "$file" ]; then
  printf '"%s" is a path to a regular file or symlink to regular file\n' "$file"
Elif [ -e "$file" ]; then
  printf '"%s" exists but is not a regular file\n' "$file"
Elif [ -L "$file" ]; then
  printf '"%s" exists, is a symlink but I cannot tell if it eventually resolves to an actual file, regular or not\n' "$file"
else
  printf 'I cannot tell if "%s" exists, let alone whether it is a regular file or not\n' "$file"
fi

要确定该文件不存在,我们需要stat()系统调用返回错误代码ENOENTENOTDIR告诉我们其中一个路径组件不是目录是我们可以告诉文件的另一种情况那条路不存在)。不幸的是[命令不让我们知道。无论错误代码是ENOENT,EACCESS(权限被拒绝),ENAMETOOLONG还是其他任何内容,它都将返回false。

[ -e "$file" ]测试也可以使用ls -Ld -- "$file" > /dev/null完成。在这种情况下,ls将告诉您为什么stat()失败,尽管信息不能以编程方式轻松使用:

$ file=/var/spool/cron/crontabs/root
$ if [ ! -e "$file" ]; then echo does not exist; fi
does not exist
$ if ! ls -Ld -- "$file" > /dev/null; then echo stat failed; fi
ls: cannot access '/var/spool/cron/crontabs/root': Permission denied
stat failed

至少ls告诉我这不是因为文件不存在它失败了。这是因为它无法判断文件是否存在。 [命令只是忽略了这个问题。

使用zsh Shell,您可以在失败的$ERRNO命令后使用[特殊变量查询错误代码,并使用$errnos模块中的zsh/system特殊数组解码该数字:

zmodload zsh/system
ERRNO=0
if [ ! -f "$file" ]; then
  err=$ERRNO
  case $errnos[err] in
    ("") echo exists, not a regular file;;
    (ENOENT|ENOTDIR)
       if [ -L "$file" ]; then
         echo broken link
       else
         echo does not exist
       fi;;
    (*) syserror -p "can't tell: " "$err"
  esac
fi

(注意 $errnos支持在使用zsh的最新版本构建时gcc的某些版本被破坏 )。

19
Stephane Chazelas

要反转测试,请使用“!”。这相当于其他语言中的“非”逻辑运算符。试试这个:

if [ ! -f /tmp/foo.txt ];
then
    echo "File not found!"
fi

或以稍微不同的方式书写:

if [ ! -f /tmp/foo.txt ]
    then echo "File not found!"
fi

或者您可以使用:

if ! [ -f /tmp/foo.txt ]
    then echo "File not found!"
fi

或者,将所有人放在一起:

if ! [ -f /tmp/foo.txt ]; then echo "File not found!"; fi

可以写入(使用“和”运算符:&&)作为:

[ ! -f /tmp/foo.txt ] && echo "File not found!"

看起来像这样短:

[ -f /tmp/foo.txt ] || echo "File not found!"
10
user2350426

这段代码也有效。

#!/bin/bash
FILE=$1
if [ -f $FILE ]; then
 echo "File '$FILE' Exists"
else
 echo "The File '$FILE' Does Not Exist"
fi
9
Lemon Kazi

test也可能算在内。它适用于我(基于Bash Shell:检查文件是否存在):

test -e FILENAME && echo "File exists" || echo "File doesn't exist"
8
android developer

最简单的方法

FILE=$1
[ ! -e "${FILE}" ] && echo "does not exist" || echo "exists"
6
lancerex

此Shell脚本也适用于在目录中查找文件:

echo "enter file"

read -r a

if [ -s /home/trainee02/"$a" ]
then
    echo "yes. file is there."
else
    echo "sorry. file is not there."
fi
5
Simmant

有时使用&&和||可能很方便运营商。

喜欢(如果你有命令“test”):

test -b $FILE && echo File not there!

要么

test -b $FILE || echo File there!
3
André